﻿namespace Memento2
{
    //Originator
    //Implementa ICalculadora e restaura o estado anterior
    public class Calculadora : ICalculadora
    {
        private int primeiroNumero;
        private int segundoNumero;

        //corresponde ao método CreateMemento()
        public ICaretaker BackupUltimoCalculo()
        {
            // cria um objeto memento usado para restaurar os dois numeros
            return new Memento(primeiroNumero, segundoNumero);
        }
        public int GetCalculoResultado()
        {
            // retorna o resultado da soma dos dois numeros
            return primeiroNumero + segundoNumero;
        }
        // Corresponde ao método SetMemento() 
        // Executa a lógica para restaurar o estado anterior
        public void RestauraUltimoCalculo(ICaretaker memento)
        {
            primeiroNumero = ((IOriginator)memento).GetPrimeiroNumero();
            segundoNumero = ((IOriginator)memento).GetSegundoNumero();
        }
        public void SetPrimeiroNumero(int num1)
        {
            primeiroNumero = num1;
        }
        public void SetSegundoNumero(int num2)
        {
            segundoNumero = num2;
        }
    }
}
