﻿using System;

namespace Memento2
{
    class Program
    {
        static void Main(string[] args)
        {
            Console.WriteLine("###  Padrão Memento ###\n");
            Console.WriteLine("Calcula a soma de dois numeros e armazena o estado\n");
			Console.WriteLine("Pressione algo para realizar outro calculo e restaurar o estado anterior\n");

			// cria instancia do tipo ICalculadora
			ICalculadora calculadora = new Calculadora();

			// Atribui dois numeros
			calculadora.SetPrimeiroNumero(10);
			calculadora.SetSegundoNumero(100);

            // retorna o resultado 
            Console.WriteLine($"### Estado 1 : {calculadora.GetCalculoResultado()}");

			// Armazena o resultado caso ocorra um erro
			ICaretaker memento = calculadora.BackupUltimoCalculo();
			Console.ReadKey();

            Console.WriteLine("\nCalcula uma nova soma de dois numeros \n");
			
			// atribui outro numero
			calculadora.SetPrimeiroNumero(17);

			// atribui um segundo numero incorreto e calcula
			calculadora.SetSegundoNumero(-290);

			// exibe o resultado
			Console.WriteLine($"Estado 2 : {calculadora.GetCalculoResultado()}");

			Console.WriteLine("\nRestaura o resultado da soma anterior\n");

			// Realização operação para desfazer a ultima operação (CTRL+Z , Undo)
			calculadora.RestauraUltimoCalculo(memento);

            // Restaura o resultado do estado armazenado
            Console.WriteLine($"### Estado 1 : {calculadora.GetCalculoResultado()}");

			Console.ReadKey();
		}
    }
}
